Trigger Formula

The Trigger Formula offers a special way to store independent data in a column, but still use a formula to calculate it in some situations. It is useful to specify a column with trigger formulas which allows you to recalculate your data based on a set of conditions that you decide, clean data when a new value is entered, or provide default values for a column.

Description
app.js
index.html
styles.css
Copy to CodeMine

The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available:

Name Description
when (Required) Indicates when to trigger:
onNew: apply the formula on the data created
onNewAndUpdate: apply the formula on the data created or updated.
formula (Required) Indicates the applied formula.
[fields] (Optional) Indicates which fields could affect the formula to trigger:
* - indicates that all data field
field1,field2,field3 - indicates a series of data fields
the property could be omitted when be onNew

The sample below shows how to config the triggers:

var table = dataManager.addTable("Table", {
    schema: {
        columns: {
            createdDate: {
                dataType: "Date",
                trigger: {
                  when: "onNew",            // apply the formula on created
                  formula: "=NOW()",        // trigger formula to set current time
                  // fields: "*"            // when on new, it's no need to specify the affected fields
                },
            },
            updatedDate: {
                dataType: "Date",
                trigger: {
                  when: "onNewAndUpdate",   // apply the formula on created and updated
                  formula: "=NOW()",        // trigger formula to set current time
                  fields: "*"               // all fields changed will apply the formula
                },
            },
            label: {
                trigger: {
                    when: "onNewAndUpdate",      // apply the formula on updated
                    formula: "=UPPER([@label])"  // upper the input text of label field
                    fields: "label",             // current column value updated will apply the formula
                  },
            },
            amount: {
                dataType: "number",
                trigger: {
                    when: "onNewAndUpdate",             // apply the formula on updated
                    formula: "=[@price] * [@quantity]"  // automatic evaluate the amount
                    fields: "price,quantity",           // the changes of the price and quantity columns will apply the formula
                  },
            },
            price: { dataType: 'number' },
            quantity: { dataType: 'number' }
        },
    }
});
The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available: Name Description when (Required) Indicates when to trigger:onNew: apply the formula on the data createdonNewAndUpdate: apply the formula on the data created or updated. formula (Required) Indicates the applied formula. [fields] (Optional) Indicates which fields could affect the formula to trigger:* - indicates that all data fieldfield1,field2,field3 - indicates a series of data fieldsthe property could be omitted when be onNew The sample below shows how to config the triggers:
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); }; function updateOrderWithTriggerFormulas(spread) { var dataManager = spread.dataManager(); var orderTable = dataManager.addTable("orderTable", { remote: { read: { url: "$DEMOROOT$/spread/source/data/orderAmountTrigger.csv" } }, schema: { type: "csv", columns: { SKU: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=UPPER(TRIM([@SKU]))", // Format the input SKU text fields: "SKU" // If the SKU field be inputted, trigger the formula to format the input text } }, OrderDate: { dataType: "date", trigger: { when: "onNew", // When an order added, records the order created date formula: "=TODAY()" } }, lastUpdatedTime: { dataType: "date", trigger: { when: "onNewAndUpdate", formula: "=NOW()", fields: "*" // When any field be updated or the order be added, records the order updated time } }, lastUpdateUser: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=ACTIVEUSER()", // The user could determine how to getting the current updated user by them self fields: "*" // When any field be updated or the order be added, records the updated user } }, OrderPhone: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=IF(ISBLANK([@OrderPhone]),[@customer.Phone],[@OrderPhone])", fields: "CustomerId,OrderPhone"// Provide the customer phone when the order phone is blank } }, Amount: { dataType: "number", trigger: { when: "onNewAndUpdate", formula: "=LET(amount, [@UnitPrice] * [@Quantity], IF([@Quantity] > 30, amount * 0.8, amount))", fields: "UnitPrice,Quantity" // When the UnitPrice or Quantity fields updated or the order be added, Amount field will get a calculated result automatically } }, CustomerId: { lookup: { name: 'customer', columns: [ { value: "Id", width: 60 }, { value: "CompanyName", width: 200 }, { value: "ContactName", width: 140 }, { value: "ContactTitle", width: 140 } ] } }, Quantity: { dataType: "number" }, UnitPrice: { dataType: "number" }, } } }); var customerTable = dataManager.addTable("customerTable", { remote: { read: { url: getBaseApiUrl() + "/Customer" } } }); //add relationship between order table, customer table table dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders"); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); var myView = orderTable.addView("myView", [ { value: "Id", width: 60, visible: false }, { value: "SKU", width: 120 }, { value: "Quantity", width: 100 }, { value: "UnitPrice", width: 100 }, { value: "Amount", width: 100 }, { value: "CustomerId", caption: 'Customer', width: 120, defaultValue:'ALFKI', visible: false }, { value: "OrderPhone", caption: 'Order Phone', width: 120 }, { value: "OrderDate", width: 150, readonly: true, visible: false }, { value: "lastUpdatedTime", width: 180, readonly: true, visible: false }, { value: "lastUpdateUser", width: 150, readonly: true, visible: false }, ]); myView.fetch().then(function() { sheet.setDataView(myView); }); spread.resumePaint(); } function addActiveUserFunction() { function ActiveUserFunction() { this.name = "ACTIVEUSER"; } ActiveUserFunction.prototype = new GC.Spread.CalcEngine.Functions.Function("ACTIVEUSER", 0 ,0, { name: "ACTIVEUSER"}); ActiveUserFunction.prototype.evaluate = function () { let fakeNames = [ "Warner", "Guerrero", "Mathis", "Morton", "Knight", "Cox", "Keller", "Pena", "Maxwell", "Ford", "Bass", "Morton", "Parsons" ]; return fakeNames[Math.floor(Math.random() * fakeNames.length)]; }; GC.Spread.CalcEngine.Functions.defineGlobalCustomFunction("ACTIVEUSER", new ActiveUserFunction()); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; addActiveUserFunction(); updateOrderWithTriggerFormulas(spread); spread.resumePaint(); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="optionContainer" class="optionContainer"> </div> </div> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; }

The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available:
Name
Description
when
(Required) Indicates when to trigger:onNew: apply the formula on the data createdonNewAndUpdate: apply the formula on the data created or updated.
formula
(Required) Indicates the applied formula.
[fields]
(Optional) Indicates which fields could affect the formula to trigger:* - indicates that all data fieldfield1,field2,field3 - indicates a series of data fieldsthe property could be omitted when be onNew
The sample below shows how to config the triggers:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
function updateOrderWithTriggerFormulas(spread) {
var dataManager = spread.dataManager();
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: "$DEMOROOT$/spread/source/data/orderAmountTrigger.csv"
}
},
schema: {
type: "csv",
columns: {
SKU: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=UPPER(TRIM([@SKU]))", // Format the input SKU text
fields: "SKU" // If the SKU field be inputted, trigger the formula to format the input text
}
},
OrderDate: {
dataType: "date",
trigger: {
when: "onNew", // When an order added, records the order created date
formula: "=TODAY()"
}
},
lastUpdatedTime: {
dataType: "date",
trigger: {
when: "onNewAndUpdate",
formula: "=NOW()",
fields: "*" // When any field be updated or the order be added, records the order updated time
}
},
lastUpdateUser: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=ACTIVEUSER()", // The user could determine how to getting the current updated user by them self
fields: "*" // When any field be updated or the order be added, records the updated user
}
},
OrderPhone: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=IF(ISBLANK([@OrderPhone]),[@customer.Phone],[@OrderPhone])",
fields: "CustomerId,OrderPhone"// Provide the customer phone when the order phone is blank
}
},
Amount: {
dataType: "number",
trigger: {
when: "onNewAndUpdate",
formula: "=LET(amount, [@UnitPrice] * [@Quantity], IF([@Quantity] > 30, amount * 0.8, amount))",
fields: "UnitPrice,Quantity" // When the UnitPrice or Quantity fields updated or the order be added, Amount field will get a calculated result automatically
}
},
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
},
Quantity: { dataType: "number" },
UnitPrice: { dataType: "number" },
}
}
});
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: getBaseApiUrl() + "/Customer"
}
}
});
//add relationship between order table, customer table table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60, visible: false },
{ value: "SKU", width: 120 },
{ value: "Quantity", width: 100 },
{ value: "UnitPrice", width: 100 },
{ value: "Amount", width: 100 },
{ value: "CustomerId", caption: 'Customer', width: 120, defaultValue:'ALFKI', visible: false },
{ value: "OrderPhone", caption: 'Order Phone', width: 120 },
{ value: "OrderDate", width: 150, readonly: true, visible: false },
{ value: "lastUpdatedTime", width: 180, readonly: true, visible: false },
{ value: "lastUpdateUser", width: 150, readonly: true, visible: false },
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
function addActiveUserFunction() {
function ActiveUserFunction() {
this.name = "ACTIVEUSER";
}
ActiveUserFunction.prototype = new GC.Spread.CalcEngine.Functions.Function("ACTIVEUSER", 0 ,0, { name: "ACTIVEUSER"});
ActiveUserFunction.prototype.evaluate = function () {
let fakeNames = [
"Warner",
"Guerrero",
"Mathis",
"Morton",
"Knight",
"Cox",
"Keller",
"Pena",
"Maxwell",
"Ford",
"Bass",
"Morton",
"Parsons"
];
return fakeNames[Math.floor(Math.random() * fakeNames.length)];
};
GC.Spread.CalcEngine.Functions.defineGlobalCustomFunction("ACTIVEUSER", new ActiveUserFunction());
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
export function AppFunc() {
let spread = null;
let initSpread = function (value) {
spread = value;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
spread.options.highlightInvalidData = true;
spread.options.calcOnDemand = true;
addActiveUserFunction();
updateOrderWithTriggerFormulas(spread);
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
function updateOrderWithTriggerFormulas(spread) {
var dataManager = spread.dataManager();
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: "$DEMOROOT$/spread/source/data/orderAmountTrigger.csv"
}
},
schema: {
type: "csv",
columns: {
SKU: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=UPPER(TRIM([@SKU]))", // Format the input SKU text
fields: "SKU" // If the SKU field be inputted, trigger the formula to format the input text
}
},
OrderDate: {
dataType: "date",
trigger: {
when: "onNew", // When an order added, records the order created date
formula: "=TODAY()"
}
},
lastUpdatedTime: {
dataType: "date",
trigger: {
when: "onNewAndUpdate",
formula: "=NOW()",
fields: "*" // When any field be updated or the order be added, records the order updated time
}
},
lastUpdateUser: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=ACTIVEUSER()", // The user could determine how to getting the current updated user by them self
fields: "*" // When any field be updated or the order be added, records the updated user
}
},
OrderPhone: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=IF(ISBLANK([@OrderPhone]),[@customer.Phone],[@OrderPhone])",
fields: "CustomerId,OrderPhone"// Provide the customer phone when the order phone is blank
}
},
Amount: {
dataType: "number",
trigger: {
when: "onNewAndUpdate",
formula: "=LET(amount, [@UnitPrice] * [@Quantity], IF([@Quantity] > 30, amount * 0.8, amount))",
fields: "UnitPrice,Quantity" // When the UnitPrice or Quantity fields updated or the order be added, Amount field will get a calculated result automatically
}
},
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
},
Quantity: { dataType: "number" },
UnitPrice: { dataType: "number" },
}
}
});
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: getBaseApiUrl() + "/Customer"
}
}
});
//add relationship between order table, customer table table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60, visible: false },
{ value: "SKU", width: 120 },
{ value: "Quantity", width: 100 },
{ value: "UnitPrice", width: 100 },
{ value: "Amount", width: 100 },
{ value: "CustomerId", caption: 'Customer', width: 120, defaultValue:'ALFKI', visible: false },
{ value: "OrderPhone", caption: 'Order Phone', width: 120 },
{ value: "OrderDate", width: 150, readonly: true, visible: false },
{ value: "lastUpdatedTime", width: 180, readonly: true, visible: false },
{ value: "lastUpdateUser", width: 150, readonly: true, visible: false },
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
function addActiveUserFunction() {
function ActiveUserFunction() {
this.name = "ACTIVEUSER";
}
ActiveUserFunction.prototype = new GC.Spread.CalcEngine.Functions.Function("ACTIVEUSER", 0 ,0, { name: "ACTIVEUSER"});
ActiveUserFunction.prototype.evaluate = function () {
let fakeNames = [
"Warner",
"Guerrero",
"Mathis",
"Morton",
"Knight",
"Cox",
"Keller",
"Pena",
"Maxwell",
"Ford",
"Bass",
"Morton",
"Parsons"
];
return fakeNames[Math.floor(Math.random() * fakeNames.length)];
};
GC.Spread.CalcEngine.Functions.defineGlobalCustomFunction("ACTIVEUSER", new ActiveUserFunction());
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.options.allowDynamicArray = true;
spread.options.highlightInvalidData = true;
spread.options.calcOnDemand = true;
addActiveUserFunction();
updateOrderWithTriggerFormulas(spread);
spread.resumePaint();
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/orderDataSource.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/orderYearProductDataSource.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 210px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 3px;
margin-top: 3px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width: 100%;
text-align: center;
}
input[type=text] {
width: 230px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available:
Name
Description
when
(Required) Indicates when to trigger:onNew: apply the formula on the data createdonNewAndUpdate: apply the formula on the data created or updated.
formula
(Required) Indicates the applied formula.
[fields]
(Optional) Indicates which fields could affect the formula to trigger:* - indicates that all data fieldfield1,field2,field3 - indicates a series of data fieldsthe property could be omitted when be onNew
The sample below shows how to config the triggers:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import './styles.css';
function updateOrderWithTriggerFormulas(spread) {
var dataManager = spread.dataManager();
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: "$DEMOROOT$/spread/source/data/orderAmountTrigger.csv"
}
},
schema: {
type: "csv",
columns: {
SKU: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=UPPER(TRIM([@SKU]))", // Format the input SKU text
fields: "SKU" // If the SKU field be inputted, trigger the formula to format the input text
}
},
OrderDate: {
dataType: "date",
trigger: {
when: "onNew", // When an order added, records the order created date
formula: "=TODAY()"
}
},
lastUpdatedTime: {
dataType: "date",
trigger: {
when: "onNewAndUpdate",
formula: "=NOW()",
fields: "*" // When any field be updated or the order be added, records the order updated time
}
},
lastUpdateUser: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=ACTIVEUSER()", // The user could determine how to getting the current updated user by them self
fields: "*" // When any field be updated or the order be added, records the updated user
}
},
OrderPhone: {
dataType: "string",
trigger: {
when: "onNewAndUpdate",
formula: "=IF(ISBLANK([@OrderPhone]),[@customer.Phone],[@OrderPhone])",
fields: "CustomerId,OrderPhone"// Provide the customer phone when the order phone is blank
}
},
Amount: {
dataType: "number",
trigger: {
when: "onNewAndUpdate",
formula: "=LET(amount, [@UnitPrice] * [@Quantity], IF([@Quantity] > 30, amount * 0.8, amount))",
fields: "UnitPrice,Quantity" // When the UnitPrice or Quantity fields updated or the order be added, Amount field will get a calculated result automatically
}
},
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
},
Quantity: { dataType: "number" },
UnitPrice: { dataType: "number" },
}
}
});
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: getBaseApiUrl() + "/Customer"
}
}
});
//add relationship between order table, customer table table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60, visible: false },
{ value: "SKU", width: 120 },
{ value: "Quantity", width: 100 },
{ value: "UnitPrice", width: 100 },
{ value: "Amount", width: 100 },
{ value: "CustomerId", caption: 'Customer', width: 120, defaultValue:'ALFKI', visible: false },
{ value: "OrderPhone", caption: 'Order Phone', width: 120 },
{ value: "OrderDate", width: 150, readonly: true, visible: false },
{ value: "lastUpdatedTime", width: 180, readonly: true, visible: false },
{ value: "lastUpdateUser", width: 150, readonly: true, visible: false },
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
function addActiveUserFunction() {
function ActiveUserFunction() {
this.name = "ACTIVEUSER";
}
ActiveUserFunction.prototype = new GC.Spread.CalcEngine.Functions.Function("ACTIVEUSER", 0 ,0, { name: "ACTIVEUSER"});
ActiveUserFunction.prototype.evaluate = function () {
let fakeNames = [
"Warner",
"Guerrero",
"Mathis",
"Morton",
"Knight",
"Cox",
"Keller",
"Pena",
"Maxwell",
"Ford",
"Bass",
"Morton",
"Parsons"
];
return fakeNames[Math.floor(Math.random() * fakeNames.length)];
};
GC.Spread.CalcEngine.Functions.defineGlobalCustomFunction("ACTIVEUSER", new ActiveUserFunction());
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
addActiveUserFunction();
updateOrderWithTriggerFormulas(spread)
spread.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Trigger Formula

The Trigger Formula offers a special way to store independent data in a column, but still use a formula to calculate it in some situations. It is useful to specify a column with trigger formulas which allows you to recalculate your data based on a set of conditions that you decide, clean data when a new value is entered, or provide default values for a column.

Description
app.vue
index.html
styles.css
Copy to CodeMine

The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available:

Name Description
when (Required) Indicates when to trigger:
onNew: apply the formula on the data created
onNewAndUpdate: apply the formula on the data created or updated.
formula (Required) Indicates the applied formula.
[fields] (Optional) Indicates which fields could affect the formula to trigger:
* - indicates that all data field
field1,field2,field3 - indicates a series of data fields
the property could be omitted when be onNew

The sample below shows how to config the triggers:

var table = dataManager.addTable("Table", {
    schema: {
        columns: {
            createdDate: {
                dataType: "Date",
                trigger: {
                  when: "onNew",            // apply the formula on created
                  formula: "=NOW()",        // trigger formula to set current time
                  // fields: "*"            // when on new, it's no need to specify the affected fields
                },
            },
            updatedDate: {
                dataType: "Date",
                trigger: {
                  when: "onNewAndUpdate",   // apply the formula on created and updated
                  formula: "=NOW()",        // trigger formula to set current time
                  fields: "*"               // all fields changed will apply the formula
                },
            },
            label: {
                trigger: {
                    when: "onNewAndUpdate",      // apply the formula on updated
                    formula: "=UPPER([@label])"  // upper the input text of label field
                    fields: "label",             // current column value updated will apply the formula
                  },
            },
            amount: {
                dataType: "number",
                trigger: {
                    when: "onNewAndUpdate",             // apply the formula on updated
                    formula: "=[@price] * [@quantity]"  // automatic evaluate the amount
                    fields: "price,quantity",           // the changes of the price and quantity columns will apply the formula
                  },
            },
            price: { dataType: 'number' },
            quantity: { dataType: 'number' }
        },
    }
});
The option GC.Data.ITriggerFormulaOption can be added at the column in the data source schema. These are the properties available: Name Description when (Required) Indicates when to trigger:onNew: apply the formula on the data createdonNewAndUpdate: apply the formula on the data created or updated. formula (Required) Indicates the applied formula. [fields] (Optional) Indicates which fields could affect the formula to trigger:* - indicates that all data fieldfield1,field2,field3 - indicates a series of data fieldsthe property could be omitted when be onNew The sample below shows how to config the triggers:
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ <template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script> import Vue from "vue"; import "@mescius/spread-sheets-vue"; import GC from "@mescius/spread-sheets"; import "@mescius/spread-sheets-tablesheet"; import "./styles.css"; let App = Vue.extend({ name: "app", methods: { initSpread: function (spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; this.addActiveUserFunction(); this.updateOrderWithTriggerFormulas(spread); spread.resumePaint(); }, updateOrderWithTriggerFormulas: function (spread) { var dataManager = spread.dataManager(); var orderTable = dataManager.addTable("orderTable", { remote: { read: { url: "$DEMOROOT$/spread/source/data/orderAmountTrigger.csv" } }, schema: { type: "csv", columns: { SKU: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=UPPER(TRIM([@SKU]))", // Format the input SKU text fields: "SKU" // If the SKU field be inputted, trigger the formula to format the input text } }, OrderDate: { dataType: "date", trigger: { when: "onNew", // When an order added, records the order created date formula: "=TODAY()" } }, lastUpdatedTime: { dataType: "date", trigger: { when: "onNewAndUpdate", formula: "=NOW()", fields: "*" // When any field be updated or the order be added, records the order updated time } }, lastUpdateUser: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=ACTIVEUSER()", // The user could determine how to getting the current updated user by them self fields: "*" // When any field be updated or the order be added, records the updated user } }, OrderPhone: { dataType: "string", trigger: { when: "onNewAndUpdate", formula: "=IF(ISBLANK([@OrderPhone]),[@customer.Phone],[@OrderPhone])", fields: "CustomerId,OrderPhone"// Provide the customer phone when the order phone is blank } }, Amount: { dataType: "number", trigger: { when: "onNewAndUpdate", formula: "=LET(amount, [@UnitPrice] * [@Quantity], IF([@Quantity] > 30, amount * 0.8, amount))", fields: "UnitPrice,Quantity" // When the UnitPrice or Quantity fields updated or the order be added, Amount field will get a calculated result automatically } }, CustomerId: { lookup: { name: 'customer', columns: [ { value: "Id", width: 60 }, { value: "CompanyName", width: 200 }, { value: "ContactName", width: 140 }, { value: "ContactTitle", width: 140 } ] } }, Quantity: { dataType: "number" }, UnitPrice: { dataType: "number" }, } } }); var customerTable = dataManager.addTable("customerTable", { remote: { read: { url: getBaseApiUrl() + "/Customer" } } }); //add relationship between order table, customer table table dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders"); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); var myView = orderTable.addView("myView", [ { value: "Id", width: 60, visible: false }, { value: "SKU", width: 120 }, { value: "Quantity", width: 100 }, { value: "UnitPrice", width: 100 }, { value: "Amount", width: 100 }, { value: "CustomerId", caption: 'Customer', width: 120, defaultValue: 'ALFKI', visible: false }, { value: "OrderPhone", caption: 'Order Phone', width: 120 }, { value: "OrderDate", width: 150, readonly: true, visible: false }, { value: "lastUpdatedTime", width: 180, readonly: true, visible: false }, { value: "lastUpdateUser", width: 150, readonly: true, visible: false }, ]); myView.fetch().then(function () { sheet.setDataView(myView); }); spread.resumePaint(); }, addActiveUserFunction: function () { function ActiveUserFunction() { this.name = "ACTIVEUSER"; } ActiveUserFunction.prototype = new GC.Spread.CalcEngine.Functions.Function("ACTIVEUSER", 0, 0, { name: "ACTIVEUSER" }); ActiveUserFunction.prototype.evaluate = function () { let fakeNames = [ "Warner", "Guerrero", "Mathis", "Morton", "Knight", "Cox", "Keller", "Pena", "Maxwell", "Ford", "Bass", "Morton", "Parsons" ]; return fakeNames[Math.floor(Math.random() * fakeNames.length)]; }; GC.Spread.CalcEngine.Functions.defineGlobalCustomFunction("ACTIVEUSER", new ActiveUserFunction()); } }, }); function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } new Vue({ render: (h) => h(App), }).$mount("#app"); </script>
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app.vue'); System.import('$DEMOROOT$/en/lib/vue/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' }, '*.vue': { loader: 'vue-loader' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'css': 'npm:systemjs-plugin-css/css.js', 'vue': 'npm:vue/dist/vue.min.js', 'vue-loader': 'npm:systemjs-vue-browser/index.js', 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' } } }); })(this);